#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
from PyQt4 import QtGui, QtCore

# "Urządzenia kotłowe  przykłady obliczeniowe" Henryk Rokicki Gdańsk 1996 str. 9
def wartosc_opalowa_wzor_VDI(C,H,O,S,W):
	return 339.1*C + 1214.2*(H-O/8.) + 104.7*S - 25.1*W # kJ/kg

# "Urządzenia kotłowe  przykłady obliczeniowe" Henryk Rokicki Gdańsk 1996 str. 9
def wartosc_opalowa_wzor_Gumza_Michela(C,H,N,O,S,W):
	return 340.4*C + 1017.4*H + 62.8*N + 190.9*S - 98.4*O - 25.1*W # kJ/kg

# "Urządzenia kotłowe  przykłady obliczeniowe" Henryk Rokicki Gdańsk 1996 str. 9
def wartosc_opalowa_wzor_Boie(C,H,N,O,S,W):
	return 348.3*C + 938.7*H + 104.7*S + 62.8*N - 108.*O - 24.5*W # kJ/kg

def wartosc_opalowa_gazu_udzialy_procentowo(CH4=0,C2H6=0,C3H8=0,CO=0,H2=0): # udzialy procentowe skladnikow gazu
        return 0.01*(35818.*CH4+63748.*C2H6+91251.*C3H8+10790.*H2+12690.*CO) # kJ/um3
	
def wartosc_opalowa_gazu(CH4=0,C2H6=0,C3H8=0,CO=0,H2=0): # udzialy objetosciowe skladnikow gazu
        return 35818.*CH4+63748.*C2H6+91251.*C3H8+10790.*H2+12690.*CO # kJ/um3


class WprowadzanieDanej(QtGui.QWidget):

    def __init__(self, nazwa_danej, wartosc_poczontkowa):      
        super(WprowadzanieDanej, self).__init__()
        
        self.vbox = QtGui.QVBoxLayout()
        self.dana_text = QtGui.QLabel(nazwa_danej, self)
        self.dana = QtGui.QDoubleSpinBox(self)
        self.dana.setMaximum(100)
        self.dana.setMinimum(0)
        self.dana.setValue(wartosc_poczontkowa)
        self.vbox.addWidget(self.dana_text)
        self.vbox.addWidget(self.dana)
        self.setLayout(self.vbox)
        

class WartoscOpalowa(QtGui.QWidget):
  
    def __init__(self):
        super(WartoscOpalowa, self).__init__()

	self.okienka_danych_dla_gazu()

	self.licz()



    def okienka_danych_dla_gazu(self):
      
        self.setFixedSize(400, 350)
        self.setWindowTitle(u"WARTOŚĆ OPAŁOWA, MJ/m3")

	self.vbox = QtGui.QVBoxLayout()
	
        self.CH4 = WprowadzanieDanej(u"CH4, %", 100.0)
        self.connect(self.CH4.dana, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.CH4)
        
        self.C2H6 = WprowadzanieDanej(u"C2H6, %", 0.0)
        self.connect(self.C2H6.dana, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.C2H6)
        
        self.C3H8 = WprowadzanieDanej(u"C3H8, %", 0.0)
        self.connect(self.C3H8.dana, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.C3H8)
        
        self.CO = WprowadzanieDanej(u"CO, %", 0.0)
        self.connect(self.CO.dana, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.CO)
        
        self.H2 = WprowadzanieDanej(u"H2, %", 0.0)
        self.connect(self.H2.dana, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.H2)        

        self.wyniki = QtGui.QTextEdit('', self)
                        
        self.hbox = QtGui.QHBoxLayout()
        self.hbox.addLayout(self.vbox)
        self.hbox.addWidget(self.wyniki)
        
        self.setLayout(self.hbox)



    def licz(self):
      
      suma = self.CH4.dana.value() + self.C2H6.dana.value() + self.C3H8.dana.value() + self.CO.dana.value() + self.H2.dana.value()
     
      wynik = "suma = %s%s\n\n" % (suma, "%")
      
      wynik += u"wartość opałowa wynosi = %s MJ/um3"  % (round((wartosc_opalowa_gazu_udzialy_procentowo(self.CH4.dana.value(), self.C2H6.dana.value(), self.C3H8.dana.value(), self.CO.dana.value(), self.H2.dana.value())/1000.), 2))
     
      wynik += u"\n\n\n\n\n\n\nautor programu: Tomasz Kamiński\n"
      wynik += u"W przypadku pytań: tomasz_kaminski_gdansk@wp.pl"
     
      self.wyniki.setText(wynik)


app = QtGui.QApplication(sys.argv)
icon = WartoscOpalowa()
icon.show()
app.exec_()

